package net.mcreator.target.network.message;

import net.mcreator.target.init.TargetModItems;
import net.mcreator.target.init.TargetModTags;
import net.mcreator.target.network.TargetModVariables;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraftforge.network.NetworkEvent;

import java.util.function.Supplier;

public class ReloadMessage {
    private final int type;

    public ReloadMessage(int type) {
        this.type = type;
    }

    public static ReloadMessage decode(FriendlyByteBuf buffer) {
        return new ReloadMessage(buffer.readInt());
    }

    public static void encode(ReloadMessage message, FriendlyByteBuf buffer) {
        buffer.writeInt(message.type);
    }

    public static void handler(ReloadMessage message, Supplier<NetworkEvent.Context> contextSupplier) {
        NetworkEvent.Context context = contextSupplier.get();
        context.enqueueWork(() -> {
            if (context.getSender() != null) {
                pressAction(context.getSender(), message.type);
            }
        });
        context.setPacketHandled(true);
    }

    public static void pressAction(Player player, int type) {
        Level level = player.level();

        if (!level.isLoaded(player.blockPosition()))
            return;
        if (type == 0) {
            ItemStack stack = player.getMainHandItem();
            var capability = player.getCapability(TargetModVariables.PLAYER_VARIABLES_CAPABILITY, null).orElse(new TargetModVariables.PlayerVariables());

            if (!player.isSpectator()
                    && stack.is(TargetModTags.Items.GUN)
                    && !capability.zooming
                    && !stack.getOrCreateTag().getBoolean("charging")
                    && !(player.getCooldowns().isOnCooldown(stack.getItem()))
                    && stack.getOrCreateTag().getInt("gun_reloading_time") == 0
            ) {
                CompoundTag tag = stack.getOrCreateTag();

                boolean can_reload = tag.getDouble("normal_reload_time") != 0 || tag.getDouble("empty_reload_time") != 0;

                boolean can_single_reload = tag.getDouble("iterative_time") != 0;

                //检查备弹
                if (stack.is(TargetModTags.Items.SHOTGUN) && capability.shotgunAmmo == 0) {
                    return;
                } else if (stack.is(TargetModTags.Items.SNIPER_RIFLE) && capability.sniperAmmo == 0) {
                    return;
                } else if ((stack.is(TargetModTags.Items.HANDGUN) || stack.is(TargetModTags.Items.SMG)) && capability.handgunAmmo == 0) {
                    return;
                } else if (stack.is(TargetModTags.Items.RIFLE) && capability.rifleAmmo == 0) {
                    return;
                } else if (stack.getItem() == TargetModItems.TASER.get() && tag.getInt("max_ammo") == 0) {
                    return;
                } else if (stack.getItem() == TargetModItems.M_79.get() && tag.getInt("max_ammo") == 0) {
                    return;
                } else if (stack.getItem() == TargetModItems.RPG.get() && tag.getInt("max_ammo") == 0) {
                    return;
                }
                if (can_reload) {
                    if (stack.is(TargetModTags.Items.OPEN_BOLT)) {
                        if (stack.getItem() == TargetModItems.M_60.get() || stack.getItem() == TargetModItems.ABEKIRI.get()) {
                            if (tag.getInt("ammo") < tag.getDouble("mag")) {
                                tag.putBoolean("start_reload", true);
                            }
                        } else {
                            if (tag.getInt("ammo") < tag.getDouble("mag") + 1) {
                                tag.putBoolean("start_reload", true);
                            }
                        }
                    } else if (tag.getInt("ammo") < tag.getDouble("mag")) {
                        tag.putBoolean("start_reload", true);
                    }
                    return;
                }
                if (can_single_reload) {
                    if (tag.getInt("ammo") < tag.getDouble("mag")) {
                        tag.putBoolean("start_single_reload", true);
                    }
                }
            }
        }
    }
}
